# TERRAFORM PROJECT TEMPLATE

## AWS Architecture
[ENTER DRAWING OF THE PROJECT ARCHITECTURE]

## Repository Structure
```sh
project_name    # Repository with Infrastucture Code (Terraform)
    ├── env         # Environment specific vaiable files (TFVARS)
    ├── python      # Source code in python (usually for lambda functions)
    ├── scripts         # Bash Scripts for maintenance operations
    └── modules         # Terraform Modules
       ├── core         # Core Component for the platform
       ├── other
       └── ...
```

## Installation & Maintenance


### Deploy or Update the Stack
- Shell requires Terraform (https://developer.hashicorp.com/terraform/tutorials/aws-get-started/install-cli)
- Shell session requires AWS credentials
- Execute : `./scripts/deploy.sh`

### Destroy
- Execute : `./scripts/the-destroy.sh`

## Other Terraform Usefule Commands
https://developer.hashicorp.com/terraform/cli/commands

``` bash

# Set env var
source ./scripts/_set-env.sh

# See all followed resource
terraform state list

# See details of a resource
terraform state show <resource id>

# remove a resource
terraform state rm <resource id>
```

## Developpers Notes

### Format terrform code
``` sh
terraform fmt --recursive
```

### Format & Lint Python code
``` sh
ruff format python
ruff check python
pytest python
```

