
# https://registry.terraform.io/providers/hashicorp/random/latest/docs/resources/string
resource "random_string" "s3_suffix" {
  length  = 6
  lower   = true
  upper   = false
  special = false
}

data "external" "tf_source_repo" {
  program = ["bash", "${path.module}/scripts/get_git_info.sh"]
}

# General Local Variables
locals {
  project = "[project_name]"
}
locals {
  prefix = "${var.corp_prefix}-${local.project}-${var.environment}"
}
locals {
  s3_prefix = "${local.prefix}-${random_string.s3_suffix.result}"
  base_tags = {
    ManagedBy   = "Terraform"
    Environment = var.environment
    StateFile   = "s3://${var.tf_state_bucket}/${var.tf_state_file}"
    SourceRepo  = data.external.tf_source_repo.result.url
  }
}
locals {
  common_tags = merge(
    local.base_tags,
    { "${var.cost_allocation_tag}" = local.project }
  )
}






