#!/bin/bash
# Helps to DESTROY the terraform project manually

set -e

yesNo () {
    while true; do
        read -r -p "$1 (y/n): " answer
        case $answer in
            [Yy]* ) echo 'y'; return 0;;
            [Nn]* ) echo 'n'; return 0;;
            * ) echo "Please answer Y or N.";;
        esac
    done
}

if [ -z ${TARGET_PROJECT+x} ]; then
    source ./scripts/_set-env.sh
fi

echo "--- TF Variables File Content ------------------------------------------------------------"
cat $TF_VARIABLES_FILE
echo "------------------------------------------------------------------------------------------"

terraform init \
    -backend-config="bucket=$TF_STATE_BUCKET" \
    -backend-config="key=$TF_STATE_FILE" \
    -backend-config="region=$TARGET_REGION" \
    -var-file=$TF_VARIABLES_FILE \
    -upgrade \
    -reconfigure


answer=$(yesNo "YOU ARE SURE YOU WANT TO DESTROY ?")

terraform destroy -var-file=$TF_VARIABLES_FILE
